#ifndef _FS2_H_
#define _FS2_H_

// FS ˻Ѥ EEPROM Ƭɥ쥹
#define EEPROM_FS ((uint8_t *)0)

// E2END ǽɥ쥹(511), E2END-EEPROM_FS+1 Ѳǽ
// 񤭹߲ϿѤ˾ʤȤ -4  4 ХȤۤɤ
#define FS_SIZE (E2END-(uint16_t)EEPROM_FS+1-4)


#define FS_OK            0
#define FS_EOF           1
#define FS_NOTFOUND      2
#define FS_DISKFULL      3
#define FS_ALREADYOPENED 4
#define FS_CHECKSUMERROR 5

#define FS_CLOSED 0
#define FS_OPENED 1

#define fs_EOF() ((fs_pt>=fs_head_addr+3+fs_size)||fs_size==0xffff)
#define fs_format() do { int i; for (i=0;i<FS_SIZE;i++) eeprom_write_byte(EEPROM_FS+i, 0xff); fs_init(); } while(0)

#define fs_search(fn) fs_ropen(fn)

// Хѿ
extern uint8_t fs_filename;
extern uint8_t *fs_head_addr, *fs_final_addr;
extern uint16_t fs_size;
extern uint8_t fs_wopenflag;
extern uint8_t *fs_pt;

// ץȥ
void fs_init(void);
uint8_t fs_ropen(uint8_t fn);
uint8_t fs_delete(uint8_t fn);
uint8_t fs_wopen(uint8_t fn);
uint8_t fs_wclose(void);
uint8_t fs_write_b(uint8_t val);
uint8_t fs_read_b(void);
uint16_t fs_free(void);
char* fs_str_r(char *str, uint8_t fn, uint16_t maxlen);
uint8_t fs_str_w(char *str, uint8_t fn);
void fs_zerodelete(void);
uint8_t fs_write_w(uint16_t val);
uint16_t fs_read_w(void);
unsigned char getCheckSum(unsigned char fn);

// ա˲Ū fs_search() ƤΤǡեݥ󥿤Ƭ֤˰ưޤ
uint16_t fs_filesize(unsigned char fn);

#endif
